#include <iostream>
#include <string>

using namespace std;

const int ALPHABET_SIZE = 26;

void cntFreq(string str, int freq[], char opr);

bool isAnagram(int *freq, const int size);

int main() {
    string str1, str2;
    cout << "Please enter the first string:\n";
    getline(cin, str1);
    cout << "Please enter the second string:\n";
    getline(cin, str2);

    int freq[ALPHABET_SIZE] = {0};

    // Count the occurrences of each letter in `str1`
    // and store it in `freq` (Increase the corresponding element's value by 1 each time)
    cntFreq(str1, freq, '+');

    // Count the occurrences of each letter
    // and in `freq` decrease the corresponding element's value by 1 each time
    cntFreq(str2, freq, '-');

    cout << "The two strings are"
         << (isAnagram(freq, ALPHABET_SIZE) ? " " : " not ")
         << "anagrams.\n";

    return 0;
}

void cntFreq(string str, int freq[], char opr) {
    for (char c: str) {
        if (isupper(c)) {
            if (opr == '+') {
                ++freq[int(c) - int('A')];
            } else {
                --freq[int(c) - int('A')];
            }
        } else if (islower(c)) {
            if (opr == '+') {
                ++freq[int(c) - int('a')];
            } else {
                --freq[int(c) - int('a')];
            }
        }
    }
}

bool isAnagram(int *freq, const int size) {
    for (int i = 0; i < size; ++i) {
        if (freq[i] != 0) return false;
    }
    return true;
}